#!/usr/bin/env python3


"""                          _    _
                            | |  (_)
 _ __  _   _ _ __ ___  _ __ | | ___ _ __    _ __   __ _  ___ _ __ ___   __ _ _ __
| '_ \| | | | '_ ` _ \| '_ \| |/ / | '_ \  | '_ \ / _` |/ __| '_ ` _ \ / _` | '_ \
| |_) | |_| | | | | | | |_) |   <| | | | | | |_) | (_| | (__| | | | | | (_| | | | |
| .__/ \__,_|_| |_| |_| .__/|_|\_\_|_| |_| | .__/ \__,_|\___|_| |_| |_|\__,_|_| |_|
| |                   | |                  | |
|_|                   |_|                  |_|                                  """

# bron:
#    https://pythonprogramming.altervista.org/simple-labytinth-in-pygame/
#
# meer oefeningen:
#    https://www.w3resource.com/python-exercises/python-functions-exercises.php

__author__: "<uw naam>"
__klas__: "<uw klas>"
__date__: "27/10/2023"

# Gelieve de opdrachten beneden op te lossen en 
# het resultaat op smartschool in de uploadzone te plaatsen!


#________________________________________________________________________________
# Oefening 0: Voorbereiding
"""
- installeer "pygame" (via "pip")
- download de spelbibliotheek en twee beeldjes van de website:
    + https://mielke.ws/dat/pacman.py
    + https://mielke.ws/dat/pompoen.jpg
    + https://mielke.ws/dat/snoep.jpg
"""

from pacman import TheGame


#________________________________________________________________________________
# Oefening 1: Functies
"""
Pas de functie beneden zo aan
dat de pompoen (of: gele veld) op het snoepje (of: rode veld) belandt.
"""

def Oefening1():
    # hier wordt een eenvoudige schakbord-spelveld aangemaakt.
    level1 = [
        "WWWWWWW",
        "W   WEW",
        "W S W W",
        "W   W W",
        "W     W",
        "WWWWWWW",
       ]

    # hier wordt het spel geïnitialiseerd
    game = TheGame(level1, img_path = 'pompoen.jpg', snoep_img = 'snoep.jpg')
    player = game.player


    # hier is een demo-functie:
    #         [!] pas deze functie zo aan dat de pompoen zijn doel bereikt
    def MyTestFunction():
        # zet hier uw lijst van commando's
        player.MoveUp()
        player.MoveRight()
        player.Wait()
        player.MoveDown()
        player.MoveLeft()


    # En hier laten we de functie uitvoeren.
    game.RunFunction(MyTestFunction)

Oefening1()

#________________________________________________________________________________
# Oefening 2: Nog een functie!
"""
... en hier nog een "level".
dat de pompoen (of: gele veld) op het snoepje (of: rode veld) belandt.
Deze keer moet u ook de initialisatie en "RunFunction" overnemen.
"""

def Oefening2():
    level2 = [
        "WWWWWWWWWWWWWWWWWWWW",
        "W     W            W",
        "W S   W            W",
        "W     W      W   E W",
        "W            W     W",
        "W            W     W",
        "WWWWWWWWWWWWWWWWWWWW",
       ]

# Oefening2()

#________________________________________________________________________________
# Oefening 3: Meetingen
# a) bewegingsgeschiedenis
"""
Pas de functies boven aan zo dat ze de bewegingsgeschiedenis in een tekstcode of lijst terug geven (gebruik `return`),
bv. "^>.v<" voor "up, right, wait, down, left".
"""

# b) stappen tellen
"""
Maak er een functie aan die 
 - een bewegingsgeschiedenis als input krijgt
 - de stappen telt en returnt!
"""


# c) afstand meten
"""
Maak er een andere functie aan die de weg integreerd en het afstand van eind- en startpunt berekent.
Gebruik de Euclidse afstand: https://nl.wikipedia.org/wiki/Afstand_(wiskunde)#Tussen_twee_punten
"""



#________________________________________________________________________________
# Oefening 3: The Real Pacman!!
"""
[Dit is helemaal een bonus-oefening voor wie er al zin in heeft.]

U kan dit programma al met de pijltjes bedienen met
    game.Run()
Opdracht: maak er een echte pacman van!
- ontwerp een boeiend labyrint
- zet er spookjes* in
- laat de spookjes* bewegen!

* hiervoor moet u de bibliotheek "pacman.py" aanpassen.

Succes!

"""
